

#include <iostream>
#include <math>

using namespace std;

class Rettangolo {

     float base, altezza;

     public:

     // re-dichiara il costruttore senza parametri
     Rettangolo()
     {

     }

     // costruttore con parametri -> base e altezza inizializzati
     Rettangolo(float b, float h)
     {
         base = b;
         altezza = h;
     }

     // soliti metodi di Rettangolo
     float area()
     {
         return(base * altezza);
     }

     float perimetro()
     {
         return((base + altezza) * 2);
     }

     float diagonale()
     {
          return(sqrt(pow(base,2) + pow(altezza,2)));
     }     
};

// classe Quadrato che eredita da Rettangolo
class Quadrato: public Rettangolo
{
     Rettangolo r;     // sfrutta un oggetto Rettangolo per operare su Quadrato

     public:

     // dato il lato del quadrato inizializza il relativo Rettangolo
     // come un caso particolare (base = altezza)
     Quadrato(float lato)
     {
          r = Rettangolo(lato, lato);
     }

     // sfrutta per implementare ogni metodo
     // di Quadrato gli analoghi di Rettangolo
     float area()
     {
         return(r.area());
     }

     float perimetro()
     {
         return(r.perimetro());
     }

     float diagonale()
     {
         return(r.diagonale());
     }
};


int main()
{
    Quadrato q(10);     // creazione con inizializzazione di un oggetto Quadrato

    // applicazione dei metodi di Quadrato
    cout << "Area quadrato:  " << q.area() << endl;
    cout << "Perimetro quadrato:  " << q.perimetro() << endl;
    cout << "Diagonale quadrato:  " << q.diagonale() << endl;

    cin.get();    // attende Enter per uscire

    return 0;
}


 